/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Modela las caractersticas que queremos de un esqueleto
*/
#include "Esqueleto.h"

Esqueleto::Esqueleto(void)
{
	actualizado=0;

	if(brazo1.size()==0){
		brazo1.push_back(cvPoint(0,0));
		brazo1.push_back(cvPoint(0,0));
	}
	if(brazo2.size()==0){
		brazo2.push_back(cvPoint(0,0));
		brazo2.push_back(cvPoint(0,0));
	}
	if(antebrazo1.size()==0){
		antebrazo1.push_back(cvPoint(0,0));
		antebrazo1.push_back(cvPoint(0,0));
	}
	if(antebrazo2.size()==0){
		antebrazo2.push_back(cvPoint(0,0));
		antebrazo2.push_back(cvPoint(0,0));
	}
}
Esqueleto::~Esqueleto(void)
{
}

void Esqueleto::setCabeza(CvRect cabezaIn){
	cabeza=cabezaIn;
}
CvRect Esqueleto::getCabeza(){
	return cabeza;
}
void Esqueleto::setCuello(vector<CvPoint>cuelloIn){
	cuello=cuelloIn;
}
vector<CvPoint> Esqueleto::getCuello(){
	return cuello;
}
void Esqueleto::setClavicula(vector<CvPoint> claviculaIn){
	clavicula=claviculaIn;
}
vector<CvPoint> Esqueleto::getClavicula(){
	return clavicula;
}
void Esqueleto::setTronco(vector<CvPoint> troncoIn){
	tronco=troncoIn;
}
vector<CvPoint> Esqueleto::getTronco(){
	return tronco;
}
void Esqueleto::setBrazo1(vector<CvPoint> brazoIn){
	if(brazoIn.size()==3){
		antebrazo1[0]=brazoIn[0];
		antebrazo1[1]=brazoIn[1];
		brazo1[0]=brazoIn[1];
		brazo1[1]=brazoIn[2];
	}else if(brazoIn.size()==2){
		antebrazo1[0]=brazo1[0];
		antebrazo1[1]=cvPoint((brazoIn[1].x + brazoIn[1].x)/2,(brazoIn[1].y + brazoIn[1].y)/2);
		brazo1[0]=antebrazo1[1];
		brazo1[1]=brazoIn[1];
	}
}
vector<CvPoint> Esqueleto::getBrazo1(){
	vector<CvPoint> resultado = antebrazo1;
	resultado.insert(resultado.end(), brazo1.begin(), brazo1.end());
	return resultado;
}
void Esqueleto::setBrazo2(vector<CvPoint>brazoIn){
	if(brazoIn.size()==3){
		antebrazo2[0]=brazoIn[0];
		antebrazo2[1]=brazoIn[1];
		brazo2[0]=brazoIn[1];
		brazo2[1]=brazoIn[2];
	}else if(brazoIn.size()==2){
		antebrazo2[0]=brazo2[0];
		antebrazo2[1]=cvPoint((brazoIn[1].x + brazoIn[1].x)/2,(brazoIn[1].y + brazoIn[1].y)/2);
		brazo2[0]=antebrazo2[1];
		brazo2[1]=brazoIn[1];
	}
}
vector<CvPoint> Esqueleto::getBrazo2(){
	vector<CvPoint> resultado = antebrazo2;
	resultado.insert(resultado.end(), brazo2.begin(), brazo2.end());
	return resultado;
}

void Esqueleto::setCadera(vector<CvPoint> in){
	cadera=in;
}
vector<CvPoint> Esqueleto::getCadera(){
	return cadera;
}
void Esqueleto::setPierna1(vector<CvPoint> in){
	pierna1=in;
}
vector<CvPoint> Esqueleto::getPierna1(){
	return pierna1;
}
void Esqueleto::setPierna2(vector<CvPoint> in){
	pierna2=in;
}
vector<CvPoint> Esqueleto::getPierna2(){
	return pierna2;
}

vector<CvPoint> Esqueleto::getPuntos(){//para el flujo optico
	vector<CvPoint> resultado;
	resultado.push_back(cvPoint(cabeza.x,cabeza.y));
	resultado.push_back(cvPoint(cabeza.x+cabeza.width,cabeza.y+cabeza.height));
	resultado.insert(resultado.end(), cuello.begin(), cuello.end());
	resultado.insert(resultado.end(), clavicula.begin(), clavicula.end());
	resultado.insert(resultado.end(), brazo1.begin(), brazo1.end());
	resultado.insert(resultado.end(), antebrazo1.begin(), antebrazo1.end());
	resultado.insert(resultado.end(), brazo2.begin(), brazo2.end());
	resultado.insert(resultado.end(), antebrazo2.begin(), antebrazo2.end());
	resultado.insert(resultado.end(), tronco.begin(), tronco.end());
	return resultado;
}
void Esqueleto::setPuntos(vector<CvPoint> puntos){//para el flujo optico
	if(puntos.size()>13){
		CvRect nuevaCabeza = cvRect(puntos[0].x,puntos[0].y, puntos[1].x-puntos[0].x, puntos[1].y - puntos[0].y);
		cabeza=nuevaCabeza;
		cuello[0]=puntos[2];
		cuello[1]=puntos[3];
		clavicula[0]=puntos[4];
		clavicula[1]=puntos[5];
		brazo1[0]=puntos[6];
		brazo1[1]=puntos[7];
		antebrazo1[0]=puntos[8];
		antebrazo1[1]=puntos[9];
		brazo2[0]=puntos[10];
		brazo2[1]=puntos[11];
		antebrazo2[0]=puntos[12];
		antebrazo2[1]=puntos[13];
		tronco = vector<CvPoint>(puntos.begin()+14,puntos.end());
	}else{
		actualizado=-1;
	}
}
int Esqueleto::getPosicion(){
	posicion=-1;
	CvPoint pInferiorCabeza, pSuperiorCabeza, pMano1, pMano2, pHombro1, pHombro2;

	//asignamos valores a los puntos de referencia
	pInferiorCabeza=cvPoint (cabeza.x+cabeza.width/2,cabeza.y);
	pInferiorCabeza=cvPoint (cabeza.x+cabeza.width/2,cabeza.y + cabeza.height);
	pMano1=antebrazo1.back();
	pMano2=antebrazo2.back();
	pHombro1=brazo1[0];
	pHombro2=brazo2[0];

	//comprobacion del caso

	/*comprobamos si estamos en el caso 9 - las dos manos levantadas*/
	if((pMano1.y-pHombro1.y!=0) && (pMano2.y-pHombro2.y!=0)){//asegurarnos que no dividimos por cero
		double derivada1=0.0;
		derivada1=(pHombro1.x - pMano1.x)/(pHombro1.y - pMano1.y);
		double derivada2=0.0;
		derivada2=(pHombro2.x - pMano2.x)/(pHombro2.y - pMano2.y);
		
		if((pHombro1.y > pMano1.y) && (pHombro2.y > pMano2.y)){//las manos estan levantadas por encima del hombro
			if((fabs(derivada1)<0.8) && (fabs(derivada2)<0.8) ){
				posicion=9;
				return posicion;
			}
		}
	}
	/*comprobamos si estamos en el caso 7 - forma de L invertida*/
	if(pMano1.y-pHombro1.y!=0){//asegurarnos que no dividimos por cero
		double derivada=0.0;
		derivada=(pHombro1.x - pMano1.x)/(pHombro1.y - pMano1.y);
		if(pHombro1.y > pMano1.y){//la mano esta levantada por encima del hombro
			if(fabs(derivada)<0.8){
				posicion=7;
				return posicion;
			}
		}
	}
	/*comprobamos si estamos en el caso 8 - forma de L*/
	if(pMano2.y-pHombro2.y!=0){//asegurarnos que no dividimos por cero
		double derivada=0.0;
		derivada=(pHombro2.x - pMano2.x)/(pHombro2.y - pMano2.y);
		if(pHombro2.y > pMano2.y){//la mano esta levantada por encima del hombro
			if(fabs(derivada)<0.8){
				posicion=8;
				return posicion;
			}
		}
	}
	double derivada1=0.0;
	derivada1=(pHombro1.y - pMano1.y)/(pHombro1.x - pMano1.x);
	double derivada2=0.0;
	derivada2=(pHombro2.y - pMano2.y)/(pHombro2.x - pMano2.x);
	/*comprobamos si estamos en el caso6 - los dos brazos hacia la derecha*/
	if(((pMano1.x-pHombro1.x)>0) && ((pMano2.x-pHombro2.x)>0)){
		posicion=6;
		return posicion;
	}
	/*comprobamos si estamos en el caso5 - los dos brazos hacia la izquierda*/
	if(((pMano1.x-pHombro1.x)<10) && ((pMano2.x-pHombro2.x)<10)){
		posicion=5;
		return posicion;
	}
	/*comprobamos si estamos en el caso4 - los dos brazos estirados*/
	if(((pMano1.x-pHombro1.x)<10) && ((pMano2.x-pHombro2.x)>10)){
		posicion=4;
		return posicion;
	}
	/*comprobamos si estamos en el caso3 - brazo derecho levantado*/
	if((pMano2.x-pHombro2.x)>10){
		posicion=3;
		return posicion;
	}
	/*comprobamos si estamos en el caso2 - brazo izquierdo levantado*/
	if((pMano1.x-pHombro1.x)<10){
		posicion=2;
		return posicion;
	}
	/*comprobamos si estamos en el caso1*/

	return posicion;//devolvemos -1 diciendo que no sabemos
}
//void Esqueleto::setPosicion(int posicionIn){
//	posicion=posicionIn;
//}