/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Genera una mscara siendo de color negro la silueta de la persona y blanco el fondo
		Puede haber ruido en la mscara
*/
#include "FBorde.h"


FBorde::FBorde(void){
	//http://opencv.willowgarage.com/documentation/c/imgproc_feature_detection.html#cvCanny
	edge_thresh = 100;//50;//100//120//el ultimo dia 0
	edge_thresh2 = 220;//100;//50//255//el ultimo dia 255
	aperture_sobel= 3;//3
	hdims = 256;
	hist_size = 256;
	float hranges_arr[] = {0,180};
	float* hranges = hranges_arr;

	CvSize tam = OpcionesNegocio::getOpcionesNegocio()->getTamImagen();
	cedge = cvCreateImage(tam, IPL_DEPTH_8U, 3);
    gray = cvCreateImage(tam, IPL_DEPTH_8U, 1);
    edge = cvCreateImage(tam, IPL_DEPTH_8U, 1);
	image = cvCreateImage( tam, 8, 3 );
	hsv = cvCreateImage( tam, 8, 3 );
    hue = cvCreateImage( tam, 8, 1 );
	sat = cvCreateImage( tam, 8, 1 );
	value = cvCreateImage( tam, 8, 1 );
	hist_image = cvCreateImage( cvSize(320,200), 8, 3 );
	hist = cvCreateHist( 1, &hdims, CV_HIST_ARRAY, &hranges, 1 );

	contadorColorVerde=0.0, maxVerde=0.0;
}

FBorde::~FBorde(void)
{
}


CvScalar FBorde::hsv2rgb( float hue )
{
    int rgb[3], p, sector;
    static const int sector_data[][3]=
        {{0,2,1}, {1,2,0}, {1,0,2}, {2,0,1}, {2,1,0}, {0,1,2}};
    hue *= 0.033333333333333333333333333333333f;
    sector = cvFloor(hue);
    p = cvRound(255*(hue - sector));
    p ^= sector & 1 ? 255 : 0;

    rgb[sector_data[sector][0]] = 255;
    rgb[sector_data[sector][1]] = 0;
    rgb[sector_data[sector][2]] = p;

    return cvScalar(rgb[2], rgb[1], rgb[0],0);
}

void FBorde::generarHistograma( IplImage *imgGray, CvHistogram  *hist, IplImage *hist_image, vector<int> &v ){
    int i, bin_w, auxi = 0;
    float max_value = 0;
	double diferenciaHistogramas=0, diferenciaHistogramas2=0, dHistogramasAux=0;

	/*variables de agrupacion en regiones del histograma*/
	float umbralGanancia=0.01;
	float ganancia=0.0;
	int alturaAcumBarra=0, alturaAcumBarraPrev=0;//suma de las alturas de un bloque

	v.clear();

	cvCalcHist( &imgGray, hist, 0, NULL );
    cvGetMinMaxHistValue( hist, 0, &max_value, 0, 0 );

    cvScale( hist->bins, hist->bins, ((double)hist_image->height)/max_value, 0 );

    cvSet( hist_image, cvScalarAll(255), 0 );
    bin_w = cvRound((double)hist_image->width/hist_size);

	for( i = 1; i < hist_size; i++ ){

		int val = cvRound( cvGetReal1D(hist->bins,i)*hist_image->height);

		CvScalar color = hsv2rgb(i*180.f/hdims);
		if(i>=68 && i<109){
			cvRectangle( hist_image, cvPoint(i*bin_w,hist_image->height), cvPoint((i+1)*bin_w,hist_image->height - val), color, -1, 8, 0 );
			v.push_back(val);
		}
	}
}

/*
execute:
Detecta vegetacin aplicando filtro Canny de bordes y analizando el histograma
*/
IplImage* FBorde::execute(IplImage *frame, int frameActual){
	int i=0,j=0,k=0;

	cvCopy(frame, image, 0);
	if(image->nChannels > 1){
		cvCvtColor(image, gray, CV_BGR2GRAY);
	}
	cvNot( gray, edge );
	// Aplicar canny para detectar aristas
/*	if(tamFrame.width!=tamVideo.width || tamFrame.height!=tamVideo.height){//si el area es mas especfica, hacemos que canny sea mas permisivo
		//edge_thresh = 50;//50;//100//120//el ultimo dia 0
		//edge_thresh2 = 250;//100;//50//255//el ultimo dia 255
	}else{
	
	}
*/	
	/*Aplicamos el algoritmo*/
	cvCanny(gray, edge, (float)edge_thresh, (float)edge_thresh2, aperture_sobel);//resultado de canny en edge
	edge_thresh = 50;//50;//100//120//el ultimo dia 0 --->Volvemos a setear los valores de canny
	edge_thresh2 = 190;//100;//50//255//el ultimo dia 255 --->Volvemos a setear los valores de canny
	
	cvThreshold(gray, gray, 120, 255, CV_THRESH_BINARY );//resultado de umbralizacion radiometrica en gray//antes 120
	cvAnd( gray, edge, edge, 0 );//unimos filtro bordes con filtro radiometrico
	
	cvZero( cedge );//reset
	cvCopy( image, cedge, edge );//pasar imagen a color

	cvDilate(cedge, cedge,0,10);//para adelgazar los bordes //antes era 12
	
	cvZero( image );
	cvCopy( cedge, image, gray );//reducimos el tamao
	cvDilate(image, image,0,1);//nuevo para adelgazar los bordes
	
	return image;
}

void FBorde::finish(){}