/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Implementa el patrn factora
*/
#include "Gestor.h"

Gestor::Gestor(void)
{
	fr=new FactoriaAlgoritmos();
	opciones = OpcionesNegocio::getOpcionesNegocio();
	tam = opciones->getTamImagen();
	dibujarMascara=false;
	dibujarEsqueleto=false;
}



Gestor::~Gestor(void)
{
}


void Gestor::setMostrarEsqueleto(bool esqueleto){
	dibujarEsqueleto=esqueleto;
}
void Gestor::setMostrarMascara(bool mascara){
	dibujarMascara=mascara;
}

/*
0 devolver la imagen sin tratar
1 devolver el resultado de filtrar
2 devolver la imagen con el esqueleto generado
*/
void Gestor::reset(){
	int i,j;
	vector<string> alg;
	alg.push_back("FFloodFill");
	alg.push_back("AnalisisPersona");

	OpcionesNegocio* opciones = OpcionesNegocio::getOpcionesNegocio();
	CvSize tam=opciones->getTamImagen();
	IplImage *frame=cvCreateImage( tam, 8, 3 );

	for(i=0;i<alg.size()+1;i++){
		IplImage *image=cvCreateImage( tam, 8, 3 );
		imagenesSA.push_back(image);
	}
	algoritmos=fr->generarAlgoritmos(alg);
	play=true;
}
/*
	
*/
IplImage* Gestor::execute(IplImage* frame, int frAct){
	int i,j;

	if(play==true){
		for(i=0;i<algoritmos.size();i++){
			if(i==0){
				imagenesSA[i]=algoritmos[i]->execute(frame, frAct);
			}else{
				imagenesSA[i]=algoritmos[i]->execute(imagenesSA[i-1], frAct);
			}
		}
		imagenesSA[imagenesSA.size()-1]=dibuja(frame,imagenesSA[0],dibujarMascara, dibujarEsqueleto);
		cvCopy(imagenesSA[imagenesSA.size()-1],frame);
		return frame;
	}
	return frame;
}

IplImage *Gestor::getImage(IplImage *frame){
	imagenesSA[imagenesSA.size()-1]=dibuja(frame,imagenesSA[0],dibujarMascara, dibujarEsqueleto);
	cvCopy(imagenesSA[imagenesSA.size()-1],frame);
	return frame;
}

void Gestor::stop(){
	int i;
	for(i=0;i<algoritmos.size();i++){
		algoritmos[i]->finish();
	}
	algoritmos.clear();
	imagenesSA.clear();
	HistoricoEsqueletos *he =HistoricoEsqueletos::getHistoricoEsqueletos();
	he->clear();
	play=false;
}


vector<IplImage*> Gestor::getImagenesSA(){
	return imagenesSA;
}

IplImage* Gestor::getLastImage(){
	return imagenesSA[0];
}

void Gestor::grabarImagen(int nframe, string videoOrigen, string dir, string nombre){
	unsigned int i=0;
	CvCapture *capture = cvCaptureFromFile(videoOrigen.c_str());
	IplImage *frame = cvQueryFrame( capture );
	frame = cvQueryFrame(capture);
	int totalFrames=(int) cvGetCaptureProperty( capture , CV_CAP_PROP_FRAME_COUNT );
	for(i=1;i<nframe && i<totalFrames;i++){
		frame = cvQueryFrame(capture);
	}
	string direccion("");
	direccion = dir + nombre +".jpg";
	cvSaveImage(direccion.c_str(), frame);
}