/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Implementa el patrn factora
*/
#include "FactoriaAlgoritmos.h"
#include "Dibujar.h"
#include "cv.h"
#include "highgui.h"
#include <iostream>
#include <stdio.h>
#include <ctype.h>
#include <vector>
#include <string>
#include <sstream>
#include <math.h>

#pragma once

class Gestor
{
public:
	Gestor(void);
	~Gestor(void);
private:
	int nodo1, nodo2;
	CvCapture *capture;
	int frameAct;
	int totalFrames;
	CvSize tam;
	bool play;

	OpcionesNegocio* opciones;

	vector<string> listaAlgoritmos;//lista de nombres de algoritmos disponibles
	vector<IplImage*> imagenesSA;//imagenes de salida de los algoritmos
	FactoriaAlgoritmos *fr;
	vector<Algoritmo*> algoritmos;
	bool dibujarMascara;
	bool dibujarEsqueleto;

public:
	IplImage* execute(IplImage*, int);
	IplImage* getImage(IplImage *);
	void stop();
	void reset();
	void setMostrarEsqueleto(bool);
	void setMostrarMascara(bool);

	vector<IplImage*> getImagenesSA();
	vector<string> getListaAlgoritmos();
	IplImage* getLastImage();
	void grabarImagen(int nframe, string videoOrigen, string dir, string nombre);
};
