/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Autor:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Funciones matemticas bsicas de caracter general
*/

#pragma once

#include "cv.h"
#include "highgui.h"
#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <math.h>
#include <stdlib.h>

typedef struct {
	vector<int> maxRel;//vector de maximos relativos
	vector<int> minRel;//vector de minimos relativos
}ExtremosRelativos;

typedef struct {
	vector<int> indice;//posicion original que ocupa en el vector
	vector<int> valor;//valor de la comparacion
}tipoComparacion;

typedef struct {
	int posicion;//vector de maximos relativos
	int derivada;//vector de minimos relativos
}ParPD;//par de derivada y posicion

typedef struct {
	CvPoint min;
	CvPoint max;
	vector<CvPoint> puntos;
	ExtremosRelativos er;
}ProyeccionLineaPuntos;
	
typedef struct {
	CvPoint min;
	CvPoint max;
	vector<ProyeccionLineaPuntos> PHD;
	vector<ProyeccionLineaPuntos> PVC;
	vector<ProyeccionLineaPuntos> PHI;
	vector<ProyeccionLineaPuntos> PDD;//proyeccion diagonal decreciente hacia la derecha
	vector<ProyeccionLineaPuntos> PDI;//proyeccion diagonal decreciente hacia la izquierda
	CvRect cabeza;
	vector<CvPoint> cuello;
	vector<CvPoint> hombros;
	CvRect mano1;
	CvRect mano2;
	vector<CvPoint> brazo1;
	vector<CvPoint> brazo1Sup;
	vector<CvPoint> brazo1Inf;
	vector<CvPoint> brazo2;
	vector<CvPoint> brazo2Sup;
	vector<CvPoint> brazo2Inf;
	vector<CvPoint> columnaVertebral;
	vector<CvPoint> cadera;
	vector<CvPoint> pierna1;
	vector<CvPoint> pierna2;
}Persona;



int& max (int a, int b);

int& max (vector<int> a);
int& min (int a, int b);
int& min (vector<int> a);
/*
varDependiente: determina si x(0) o y(1) es la variable dependiente
*/
ExtremosRelativos calcularExtremosRelativos(vector<CvPoint> datos, double coeficiente, double coeficiente2, double coeficiente3,int varDependiente);
ExtremosRelativos calcularExtremosRelativos(vector<int> datos, double coeficiente, double coeficiente2, double coeficiente3);
//ExtremosRelativos filtrarEr(vector<int> datos, double coeficiente, ExtremosRelativos erIn);
vector<ParPD> filtrarEr(vector<int> datos, double coeficiente, double coeficiente2, double coeficiente3, vector<ParPD> erIn);
int comparar(const void *e1, const void *e2);
vector<tipoComparacion> ordenarQsort(vector<tipoComparacion> input);

//coeficiente1-->filtrar por relevancia (tamao del pico)
//coeficiente2-->filtrar por cercania maximo-maximo y minimo-minimo
//coeficiente3-->filtrar por cercania un maximo y un minimo