/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
*/
#include "filter.h"

Filter::Filter() : listener(0) {}

/**
 * Set the filter that will listen to updated head state events.
 * @param filter Listener that should be notified of updated events.
 */
void Filter::setListener(Filter *filter) {
	listener = filter;
}

/**
 * Notify the registered listener of an updated head state.
 * @param state The current state
 */
void Filter::notifyListener(HeadState* state) {
	if(listener) {
		listener->processPoint(state);
	}
}
