/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
*/
#ifndef IMAGE_BUFFER_H
#define IMAGE_BUFFER_H

#include <QWaitCondition>
#include <QMutex>
#include <QQueue>

#include "opencv/cxcore.h"
#include "ui_settings.h"

#include "Ret.h"

/*
 * The image buffer buffers images between the capture thread and the processing thread and provides synchronization between the two threads.
 */

class ImageBuffer {
public:
	ImageBuffer(int size);
	void addFrame(const IplImage* image);
	IplImage* getFrame();
	void clear();
private:
	QWaitCondition bufferNotEmpty;
	QWaitCondition bufferNotFull;
	QMutex mutex;
	int bufferSize;
	/** Queue of IplImage objects to store the data. **/
	QQueue<IplImage*> imageQueue;
};

#endif
