/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Processingthead se encarga de coordinar el procesado
		de dicha imagen, es decir, de solicitar a la capa de
		Lgica (a travs de ControladorLogica) que procese 
		dicho frame y le retorne otro ya procesado. El frame
		resultante es notificado al Filter dentro de un HeadState.
*/
#ifndef PROCESSING_THREAD_H
#define PROCESSING_THREAD_H

#include <QThread>
#include "ControladorNegocio.h"

class ImageBuffer;
class Filter;
class HeadState;

class ProcessingThread : public QThread {
public: 
	ProcessingThread(ImageBuffer* buffer);
	void setRootFilter(Filter* filter) { rootFilter = filter; }
	void setFlipVertical(bool fv) { flipVertical = fv; }
	void run();
	void stop();
	void stopProcessing();
	void pauseProcessing();
	void playProcessing();
	void setPrevView(bool selected){prevView=selected;}
	void toggleImage();
private:
	ImageBuffer* imageBuffer;
	Filter* rootFilter;
	HeadState* currState;
	bool flipVertical;
	bool playing;
	bool isStopProcessing;
	bool isPauseProcessing;
	bool isPlayProcessing;
	bool prevView;
	IplImage* currentFrame;
};

#endif
