/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Renderwidget (Filter), encargado de dibujar por pantalla
		la imagen notificada, la transforma de IplImage (imagen 
		del formato OpenCV) a QImage (imagen del formato de QT),
		reescala y la pinta.
*/
#ifndef RENDER_WIDGET_H
#define RENDER_WIDGET_H

#include <QWidget>
#include "filter.h"
#include "Ret.h"

class HeadState;

class RenderWidget : public QWidget, public Filter {
Q_OBJECT;
public:
	RenderWidget(QWidget* parent);
	void processPoint(HeadState* state);
	void reset();
public slots:
	void onFrameSizeChanged(int width, int height);
signals:
	void frameSizeChanged(int width, int height);
protected:
	void paintEvent(QPaintEvent*);
private:
	void updatePixmap(const IplImage* frame);
	QPixmap bufferPixmap;
	uchar* imageData;
	int imageWidth, imageHeight;
	int time;
	int frames;
};

#endif
