/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Ventana de configuracin que se incrusta en la ventana principal.
*/
#include "settings.h"
#include <QDebug>

SettingsWidget::SettingsWidget(QWidget* parent) : QWidget(parent) {
	ui.setupUi(this);
	setMinimumWidth(150);
	ui.mascara->setEnabled(false);
	ui.esqueleto->setEnabled(false);

	connect(ui.prevView, SIGNAL(stateChanged(int)), this, SLOT(onPrevViewStateChanged(int)));
	connect(ui.mascara, SIGNAL(stateChanged(int)), this, SLOT(onMaskStateChanged(int)));
	connect(ui.esqueleto, SIGNAL(stateChanged(int)), this, SLOT(onSkeletonStateChanged(int)));
	trackController=0;
}

void SettingsWidget::onPrevViewStateChanged(int state){
	emit(prevViewSelected(state == Qt::Checked));
	
	if(state == Qt::Checked){
		ui.mascara->setEnabled(false);
		ui.esqueleto->setEnabled(false);
	}else{
		ui.mascara->setEnabled(true);
		ui.esqueleto->setEnabled(true);
	}
}

void SettingsWidget::onMaskStateChanged(int state) {
	//emit(maskChanged(state == Qt::Checked));
	ControladorNegocio *controlador = ControladorNegocio::getControladorNegocio();
	controlador->setMostrarMascara(state == Qt::Checked);
	Ret *r=Ret::getRet();
	if(trackController && r->getPause() && !ui.prevView->isChecked()){
		trackController->toggleImage();
	}
}

void SettingsWidget::onSkeletonStateChanged(int state) {
	ControladorNegocio *controlador = ControladorNegocio::getControladorNegocio();
	controlador->setMostrarEsqueleto(state == Qt::Checked);
	Ret *r=Ret::getRet();
	if(trackController && r->getPause() && !ui.prevView->isChecked()){
		trackController->toggleImage();
	}
}
