/*	
	Proyecto TFG:
		AMH VIDA
	Ao:
		2011-2012.
	Version:
		1.0
	Fecha de ultima modificacion:
		18-Jul-2012.
	Fuente original:
		http://www.qtcentre.org/threads/11655-OpenCV-integration
	Modificacin:
		Jose Luis Martinez Jimenez.
	Tutores:
		Francisco Javier Finat Codes.
		Valentn Cardeoso Payo
	Descripcion:
		Trackcontroller es el que coordina todo el proco, creando
		el buffer de frames. ste crea dos hilos, Capturethread y
		Processingthread, adems de establecer un filter, que es 
		el encargado de presentar la imagen.
*/

#ifndef TRACK_CONTROLLER_H
#define TRACK_CONTROLLER_H

#include "capturethread.h"

class Filter;
class ProcessingThread;
class ImageBuffer;

class TrackController : public QObject {
Q_OBJECT;
public:
	TrackController();
	void toggleImage();
	bool isTracking();
	void setFrameSize(CaptureThread::FrameSize size) { frameSize = size; }
	CaptureThread::FrameSize getFrameSize() { return frameSize; }
	void setFrameRate(int rate) { frameRate = rate; }
	int getFrameRate() { return frameSize; }
	void setRootFilter(Filter* filter);
	ProcessingThread* getProcessingThread() { return processingThread; }
	double getFPS();
	void openFile(std::string);
	void setPrevView(bool);
public slots:
	void startTracking();
	void stopTracking();
	void pauseTracking();
	void videoEndsEvent();
public:
	int frameRate;
	CaptureThread::FrameSize frameSize;
	CaptureThread* captureThread;
	ProcessingThread* processingThread;
	ImageBuffer* imageBuffer;
	std::string filename;
};

#endif
